// File_project.cpp : Defines the entry point for the console application.

#include <stdio.h>
#include <iostream>
#include <conio.h>

void Write_out(const char* line, const int bytereader)
{
	char* l = (char *) malloc(bytereader + 1);
	memcpy(l, line,  bytereader);
	l[bytereader] = (char) 0;
	printf("%s\n", l);
	free(l);	
}

int main(int argc, char* argv[])
{
	//for (int i=0; i<argc; i++)printf("%s\n", argv[i]); 

	if (argc < 2)
	{
		printf("No file has been joined as input parameter.\n");
		printf("Press any key ...\n");
		getch();
		return EXIT_FAILURE;
	}

	int len = strlen(argv[1])+1;
	char* FileName = (char *) malloc(len);
	memcpy(FileName, argv[1], len); 

	const int LINE_BUFFER = 100;
	FILE* pFile = fopen(FileName, "r");

	if (pFile != NULL)
	{		
		printf("**********************************************************************************\n");
		printf("Successfully open file: %s\n", FileName);
		printf("**********************************************************************************\n");

		char* line; 
		char c;
		int bytereader = 0;
		int bufferlength = 0;
		while (fread(&c, sizeof(c), 1, pFile))
		{
			if (c == (char) 13 || c == (char) 10)
			{
				if (bytereader > 0)
				{
					Write_out(line, bytereader);					
					bytereader = 0;
				}
			}
			else
			{
				if (bytereader == bufferlength)
				{
					if (bufferlength == 0)
						line = (char *) malloc(bufferlength += LINE_BUFFER);
					else
						line = (char *) realloc(line, bufferlength += LINE_BUFFER);
				}
				line[bytereader++] = c;
			}
		}
		
		if (bytereader > 0)
			Write_out(line, bytereader);

		fclose(pFile);
		
		if (line != NULL)
			free(line);
	}
	else
	{
		printf("Error! Unable to open file: %s\n", FileName);
		perror(FileName);
	}

	free(FileName);
	//system("pause");
	printf("Press any key ...\n");
	getch();

	return EXIT_SUCCESS;
}

